/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	kubeovnv1 "github.com/kubeovn/kube-ovn/pkg/apis/kubeovn/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeSubnets implements SubnetInterface
type FakeSubnets struct {
	Fake *FakeKubeovnV1
}

var subnetsResource = schema.GroupVersionResource{Group: "kubeovn.io", Version: "v1", Resource: "subnets"}

var subnetsKind = schema.GroupVersionKind{Group: "kubeovn.io", Version: "v1", Kind: "Subnet"}

// Get takes name of the subnet, and returns the corresponding subnet object, and an error if there is any.
func (c *FakeSubnets) Get(ctx context.Context, name string, options v1.GetOptions) (result *kubeovnv1.Subnet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(subnetsResource, name), &kubeovnv1.Subnet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Subnet), err
}

// List takes label and field selectors, and returns the list of Subnets that match those selectors.
func (c *FakeSubnets) List(ctx context.Context, opts v1.ListOptions) (result *kubeovnv1.SubnetList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(subnetsResource, subnetsKind, opts), &kubeovnv1.SubnetList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kubeovnv1.SubnetList{ListMeta: obj.(*kubeovnv1.SubnetList).ListMeta}
	for _, item := range obj.(*kubeovnv1.SubnetList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested subnets.
func (c *FakeSubnets) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(subnetsResource, opts))
}

// Create takes the representation of a subnet and creates it.  Returns the server's representation of the subnet, and an error, if there is any.
func (c *FakeSubnets) Create(ctx context.Context, subnet *kubeovnv1.Subnet, opts v1.CreateOptions) (result *kubeovnv1.Subnet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(subnetsResource, subnet), &kubeovnv1.Subnet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Subnet), err
}

// Update takes the representation of a subnet and updates it. Returns the server's representation of the subnet, and an error, if there is any.
func (c *FakeSubnets) Update(ctx context.Context, subnet *kubeovnv1.Subnet, opts v1.UpdateOptions) (result *kubeovnv1.Subnet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(subnetsResource, subnet), &kubeovnv1.Subnet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Subnet), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeSubnets) UpdateStatus(ctx context.Context, subnet *kubeovnv1.Subnet, opts v1.UpdateOptions) (*kubeovnv1.Subnet, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(subnetsResource, "status", subnet), &kubeovnv1.Subnet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Subnet), err
}

// Delete takes name of the subnet and deletes it. Returns an error if one occurs.
func (c *FakeSubnets) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(subnetsResource, name, opts), &kubeovnv1.Subnet{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeSubnets) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(subnetsResource, listOpts)

	_, err := c.Fake.Invokes(action, &kubeovnv1.SubnetList{})
	return err
}

// Patch applies the patch and returns the patched subnet.
func (c *FakeSubnets) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *kubeovnv1.Subnet, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(subnetsResource, name, pt, data, subresources...), &kubeovnv1.Subnet{})
	if obj == nil {
		return nil, err
	}
	return obj.(*kubeovnv1.Subnet), err
}
